/* Main script BO22EB16.sql */
USE [bo22eb16]
GO
/* DROP */
    /* Drop Tables */
		DROP TABLE IF EXISTS [dbo].[Bruker];
		DROP TABLE IF EXISTS [dbo].[Måling];
		DROP TABLE IF EXISTS [dbo].[Tag_område];
		DROP TABLE IF EXISTS [dbo].[Tag_Objekt];
        DROP TABLE IF EXISTS [dbo].[Punkter_område];
		DROP TABLE IF EXISTS [dbo].[Objekt];
		DROP TABLE IF EXISTS [dbo].[Område];
		DROP TABLE IF EXISTS [dbo].[Kategorier_Bilde];
        DROP TABLE IF EXISTS [dbo].[Log_feil];
        GO
    /* Drop Procedures */
        DROP PROCEDURE IF EXISTS [dbo].[PROCEDUREtestCreatePunkt];
		DROP PROCEDURE IF EXISTS [dbo].[PROCEDUREinsertIntoObjekt];
        DROP PROCEDURE IF EXISTS [dbo].[PROCEDUREinsertIntoOmråde];
        DROP PROCEDURE IF EXISTS [dbo].[PROCEDUREUpdateObjekt];
        DROP PROCEDURE IF EXISTS [dbo].[PROCEDUREUpdateOmråde];
		DROP PROCEDURE IF EXISTS [dbo].[PROCEDUREinsertIntoKategorier_Bilde];
		DROP PROCEDURE IF EXISTS [dbo].[PROCEDUREinsertBildeIntoKategorier_Bilde];
		DROP PROCEDURE IF EXISTS [dbo].[PROCEDUREGetBildeFromKategorier_Bilde];
		DROP PROCEDURE IF EXISTS [dbo].[PROCEDUREinsertIntoBruker];
        DROP PROCEDURE IF EXISTS [dbo].[PROCEDURERemoveBruker];
        DROP PROCEDURE IF EXISTS [dbo].[PROCEDURERemoveObjekt];
        DROP PROCEDURE IF EXISTS [dbo].[PROCEDUREUpdateBruker_godkjent];
        DROP PROCEDURE IF EXISTS [dbo].[PROCEDUREUpgradeBruker_Sikkerhetsklarering];
		DROP PROCEDURE IF EXISTS [dbo].[PROCEDUREListAllBrukerFromDb];
		DROP PROCEDURE IF EXISTS [dbo].[PROCEDUREListAllKategorier_BildeFromDb];
		DROP PROCEDURE IF EXISTS [dbo].[PROCEDUREListAllMålingFromDb];
		DROP PROCEDURE IF EXISTS [dbo].[PROCEDUREListAllOmrådeFromDb];
		DROP PROCEDURE IF EXISTS [dbo].[PROCEDUREListAllTag_OmrådeFromDb];
		DROP PROCEDURE IF EXISTS [dbo].[PROCEDUREListAllTag_ObjektFromDb];
		DROP PROCEDURE IF EXISTS [dbo].[PROCEDUREListAllPunkter_områdeFromDb];
		DROP PROCEDURE IF EXISTS [dbo].[PROCEDUREListAllObjektFromDb];
        DROP PROCEDURE IF EXISTS [dbo].[PROCEDUREinsertIntoPunkter_område];
        DROP PROCEDURE IF EXISTS [dbo].[PROCEDUREinsertIntoTag_område];
        DROP PROCEDURE IF EXISTS [dbo].[PROCEDUREinsertIntoTag_Objekt];
        DROP PROCEDURE IF EXISTS [dbo].[PROCEDUREinsertIntoMåling];
        DROP PROCEDURE IF EXISTS [dbo].[PROCEDURELoggFeil];
        DROP PROCEDURE IF EXISTS [dbo].[PROCEDURERemoveOmråde];
        DROP PROCEDURE IF EXISTS [dbo].[PROCEDUREUpdateBruker_Verifisert];
        GO
    /* Drop Functions */
        DROP FUNCTION IF EXISTS [dbo].[FUNCdReturnDate];
    /* Drop Sequences */
        DROP SEQUENCE IF EXISTS [dbo].[SEQUENCEObjektIdOmrådeId];
	    DROP SEQUENCE IF EXISTS [dbo].[SEQUENCEObjektId];
	    DROP SEQUENCE IF EXISTS [dbo].[SEQUENCEOmrådeId];
        DROP SEQUENCE IF EXISTS [dbo].[SEQUENCEMålingMåling_id];
        GO
/* CREATE */
    /* Create Sequences */
		/* Create Sequence SEQUENCEObjektId */
            CREATE SEQUENCE SEQUENCEObjektId -- Brukes av både Objekt.Id 
            AS INTEGER
            START WITH 0
            INCREMENT BY 1;
		/* Create Sequence SEQUENCEOmrådeId */
            CREATE SEQUENCE SEQUENCEOmrådeId -- Brukes av Område.Id
            AS INTEGER
			START WITH 0
            INCREMENT BY 1;
        /* Create Sequence SEQUENCEMålingMåling_id */
            CREATE SEQUENCE SEQUENCEMålingMåling_id -- Brukes av både Måling
            AS INTEGER
            START WITH 0
            INCREMENT BY 1;
        GO
    /* Create Functions */
        /* Create FUNCdReturnDate*/
        CREATE FUNCTION FUNCdReturnDate( @dFecha as datetime)
            returns DATETIME
        as
        begin
            DECLARE @D AS datetimeoffset
            SET @D = CONVERT(datetimeoffset, @Dfecha) AT TIME ZONE 'W. Europe Standard Time'
            RETURN CONVERT(datetime, @D);
        end
	GO
    /* Create Tables */
        /* Create Table Kategorier_Bilde */
            CREATE TABLE Kategorier_Bilde
            (
            Kategorinavn VARCHAR(30) PRIMARY KEY,
            Bilde VARBINARY(MAX),
            );
        /* Create Table Objekt */
            CREATE TABLE Objekt
            (
            IdObjekt INTEGER 
                CONSTRAINT [ObjektIdNEXTVAL] DEFAULT (NEXT VALUE FOR [dbo].[SEQUENCEObjektId]) 
                PRIMARY KEY,
            Navn VARCHAR(30),
            Kategori VARCHAR(30) NOT NULL,
                CONSTRAINT FK_Objekt_Kategorier_Bilde FOREIGN KEY (Kategori)
                    REFERENCES [dbo].[Kategorier_Bilde] (Kategorinavn)
                    ON DELETE CASCADE
                    ON UPDATE CASCADE,
            Dato_opprettet DATETIME NOT NULL,
            Opprettet_av_bruker VARCHAR(40) NOT NULL,
            Sikkerhetsklarering INTEGER NOT NULL DEFAULT 1 CONSTRAINT check_SikkerhetsklareringObjekt CHECK ((Sikkerhetsklarering > 0) AND (Sikkerhetsklarering < 4)),
            Kommentar VARCHAR(200),
	        Lat FLOAT NOT NULL,
	        Lang FLOAT NOT NULL
            );
        /* Create Table Område */
            CREATE TABLE Område
            (
            IdOmråde INTEGER 
		        CONSTRAINT [OmrådeIdNEXTVAL] DEFAULT (NEXT VALUE FOR [dbo].[SEQUENCEOmrådeId])
		        PRIMARY KEY,
            Navn VARCHAR(30) NOT NULL,
            Dato_opprettet DATETIME NOT NULL,
            Opprettet_av_bruker VARCHAR(30) NOT NULL,
            Kommentar VARCHAR(200) NOT NULL,
            Sikkerhetsklarering INTEGER NOT NULL DEFAULT 1 CONSTRAINT check_SikkerhetsklareringOmråde CHECK ((Sikkerhetsklarering > 0) AND (Sikkerhetsklarering < 4)),
	 		Farge VARCHAR(30) DEFAULT 'Grønn',
            );
        /* Create Table Tag_Objekt */
            CREATE TABLE Tag_Objekt
            (
            IdObjekt INTEGER,
                CONSTRAINT FK_Tag_Objekt_Objekt FOREIGN KEY (IdObjekt)
	                REFERENCES [dbo].[Objekt] (IdObjekt)
	                ON DELETE CASCADE
	                ON UPDATE CASCADE,
            Tag VARCHAR(30),
            PRIMARY KEY(IdObjekt, Tag)
            );
        /* Create Table Tag_område */
            CREATE TABLE Tag_område
            (
            IdOmråde INTEGER,
		        CONSTRAINT FK_Tag_Område_Område FOREIGN KEY (IdOmråde)
	                REFERENCES [dbo].[Område] (IdOmråde)
	                ON DELETE CASCADE
	                ON UPDATE CASCADE,
            Tag VARCHAR(30),
            PRIMARY KEY(IdOmråde, Tag)
            );

        /* Create Table Punkter_område */
            CREATE TABLE Punkter_område
            (
            IdOmråde INTEGER,
                CONSTRAINT FK_Punkter_område_Område FOREIGN KEY (IdOmråde)
                    REFERENCES [dbo].[Område] (IdOmråde)
                    ON DELETE CASCADE
                    ON UPDATE CASCADE,
            Rekkefølge_punkter INTEGER,
            Lat FLOAT NOT NULL,
            Lang FLOAT NOT NULL,
            PRIMARY KEY(IdOmråde, Lat, Lang)
            );
        /* Create Table Måling */
            CREATE TABLE Måling
            (
            Navn_på_sensor VARCHAR(30),
            Verdi FLOAT NOT NULL,
            IdObjekt INTEGER 
		        CONSTRAINT FK_Måling_Objekt FOREIGN KEY (IdObjekt)
	                REFERENCES [dbo].[Objekt] (IdOmråde)
	                ON DELETE CASCADE
	                ON UPDATE CASCADE,
            Måling_id INTEGER 
                CONSTRAINT [MålingMåling_id] DEFAULT (NEXT VALUE FOR [dbo].[SEQUENCEMålingMåling_id]) 
                PRIMARY KEY,
            Dato DATETIME NOT NULL,
            Enhet VARCHAR(4) NOT NULL,
            );
        /* Create Table Bruker */
            CREATE TABLE Bruker 
            (
            Fornavn VARCHAR(30) NOT NULL,
            Etternavn VARCHAR(30) NOT NULL,
            Telefonnummer INTEGER NOT NULL,
            Epost VARCHAR(30),
            Sikkerhetsklarering INTEGER NOT NULL,
            Passord VARCHAR(100) NOT NULL,
	        Tallkode INTEGER NOT NULL,
	        Godkjent BIT NOT NULL DEFAULT 0,
            Verifisert bit NOT NULL DEFAULT 0
            PRIMARY KEY (Epost)
            );
        /* Create Table Log_feil */
            CREATE TABLE [dbo].[Log_feil]
            (
            Dato DATETIME NOT NULL,
            Klasse VARCHAR (40)
            Metode VARCHAR(40) NOT NULL,
            Feilmelding VARCHAR(400) NOT NULL
            PRIMARY KEY(Dato, Feilmelding)
            );
        GO
    /* Create Procedures */
        /* Create Procedure [PROCEDUREinsertIntoObjekt] */
            CREATE PROCEDURE [dbo].[PROCEDUREinsertIntoObjekt]
                @IdObjekt int,
                @Navn VARCHAR(30),
                @Kategori VARCHAR(30),
                @Opprettet_av_bruker VARCHAR(40),
                @Sikkerhetsklarering INTEGER,
                @Kommentar VARCHAR(200),
                @Lat FLOAT,
                @Lang FLOAT
            AS
            BEGIN
                SET NOCOUNT ON;
            INSERT INTO [dbo].[Objekt]
                ([IdObjekt], [Navn], [Kategori], [Dato_opprettet], [Opprettet_av_bruker], [Sikkerhetsklarering], [Kommentar],[Lat],[Lang])
            VALUES
                (@IdObjekt, @Navn, @Kategori, DBO.FUNCdReturnDate(getdate()), @Opprettet_av_bruker, @Sikkerhetsklarering, @Kommentar, @Lat, @Lang)
            END
            GO
        /* Create Procedure [PROCEDUREUpdateObjekt] */
            CREATE PROCEDURE [dbo].[PROCEDUREUpdateObjekt]
                @IdObjekt int,
                @Navn VARCHAR(30),
                @Kategori VARCHAR(30),
                @Sikkerhetsklarering INTEGER,
                @Kommentar VARCHAR(200),
                @Lat FLOAT,
                @Lang FLOAT
            AS
            BEGIN
                SET NOCOUNT ON;
            UPDATE [dbo].[Objekt]
                SET Navn = @Navn, Kategori = @Kategori,Sikkerhetsklarering = @Sikkerhetsklarering, Kommentar = @Kommentar, Lat = @Lat,Lang = @Lang
                WHERE IdObjekt = @IdObjekt;
            END
            GO
        /* Create Procedure [PROCEDUREUpdateOmråde] */
            CREATE PROCEDURE [dbo].[PROCEDUREUpdateOmråde]
                @IdOmråde int,
                @Navn VARCHAR(30),
                @Kommentar VARCHAR(200),
                @Sikkerhetsklarering INTEGER,
                @Farge VARCHAR(30)
            AS
            BEGIN
                SET NOCOUNT ON;
            UPDATE [dbo].[Område]
                SET Navn = @Navn,Sikkerhetsklarering = @Sikkerhetsklarering, Kommentar = @Kommentar, Farge = @Farge
                WHERE idOmråde = @IdOmråde;
            END
            GO
        /* Create Procedure [PROCEDURERemoveOmråde] */
            CREATE PROCEDURE [dbo].[PROCEDURERemoveOmråde]
                @IdOmråde int
            AS
            BEGIN
                SET NOCOUNT ON;
            DELETE from [dbo].[Område]
                WHERE IdOmråde = @IdOmråde;
            END
			GO
        /* Create Procedure [PROCEDUREinsertIntoOmråde] */
            CREATE PROCEDURE [dbo].[PROCEDUREinsertIntoOmråde]
                @idOmråde int,
                @Navn VARCHAR(30),
                @Opprettet_av_Bruker VARCHAR(40),
                @Kommentar VARCHAR(200),
                @Sikkerhetsklarering INTEGER,
                @Farge varchar(30)
            AS
            BEGIN
                SET NOCOUNT ON;
            INSERT INTO [dbo].[Område]
                ([idOmråde], [Navn], [Dato_opprettet], [Opprettet_av_bruker], [Kommentar], [Sikkerhetsklarering], [Farge])
            VALUES
                (@idOmråde, @Navn, DBO.FUNCdReturnDate(getdate()), @Opprettet_av_Bruker, @Kommentar, @Sikkerhetsklarering, @Farge)
            END
            GO
        /* Create Procedure [PROCEDUREinsertIntoPunkter_område] */
            CREATE PROCEDURE [dbo].[PROCEDUREinsertIntoPunkter_område]
                @idOmråde int,
                @Rekkefølge_punkter int,
                @Lat FLOAT,
                @Lang FLOAT
            AS
            BEGIN
                SET NOCOUNT ON;
            INSERT INTO [dbo].[Punkter_område]
                ([IdOmråde], [Rekkefølge_punkter], [lat] , [lang])
            VALUES
                (@idOmråde, @Rekkefølge_punkter,  @Lat, @Lang )
            END
            GO
        /* Create Procedure [PROCEDUREinsertIntoKategorier_Bilde] */
            CREATE PROCEDURE [dbo].[PROCEDUREinsertIntoKategorier_Bilde]
                @Kategorinavn VARCHAR(30)
            AS
            BEGIN
                SET NOCOUNT ON;
            INSERT INTO [dbo].[Kategorier_Bilde]
                ([Kategorinavn], [Bilde])
            VALUES
                (@Kategorinavn, NULL)
            END
            GO
        /* Create Procedure [PROCEDUREinsertBildeIntoKategorier_Bilde] */
            CREATE PROCEDURE [dbo].[PROCEDUREinsertBildeIntoKategorier_Bilde]
                @Kategorinavn VARCHAR(30),
                @Bilde VARBINARY(MAX)
            AS
            BEGIN
                SET NOCOUNT ON;
			UPDATE [dbo].[Kategorier_Bilde]
				SET Bilde = @Bilde
				WHERE Kategorinavn = @Kategorinavn;
            END
            GO
        /* Create Procedure [PROCEDUREGetBildeFromKategorier_Bilde] */
            CREATE PROCEDURE [dbo].[PROCEDUREGetBildeFromKategorier_Bilde]
                @Kategorinavn VARCHAR(30)
            AS
            BEGIN
                SET NOCOUNT ON;
            SELECT Kategorinavn, Bilde FROM [dbo].[Kategorier_Bilde] WHERE Kategorinavn = @Kategorinavn;
            END
            GO
        /* Create Procedure [PROCEDUREUpdateBruker_godkjent] */
            CREATE PROCEDURE [dbo].[PROCEDUREUpdateBruker_godkjent]
                @Epost VARCHAR(30),
                @Godkjent BIT
            AS
            BEGIN
                SET NOCOUNT ON;
            UPDATE [dbo].[bruker]
                SET Godkjent = @Godkjent
                WHERE Epost = @Epost;
            END
            GO
        /* Create Procedure [PROCEDUREinsertIntoBruker] */
            CREATE PROCEDURE [dbo].[PROCEDUREinsertIntoBruker]
                @Fornavn VARCHAR(30),
                @Etternavn VARCHAR(30),
                @Telefonnummer int,
                @Epost VARCHAR(30),
                @Sikkerhetsklarering INTEGER,
                @Passord VARCHAR(100),
                @Tallkode int,
                @Godkjent bit,
                @Verifisert bit
            AS
            BEGIN
                SET NOCOUNT ON;
            INSERT INTO [dbo].[bruker]
                ([Fornavn], [Etternavn], [Telefonnummer], [Epost], [Sikkerhetsklarering], [Passord ], [Tallkode],[Godkjent],[Verifisert])
            VALUES
                (@Fornavn, @Etternavn, @Telefonnummer, @Epost, @Sikkerhetsklarering, @Passord, @tallkode, @Godkjent, @Verifisert)
            END
            GO
        /* Create Procedure [PROCEDURERemoveBruker] */
            CREATE PROCEDURE [dbo].[PROCEDURERemoveBruker]
                @Epost VARCHAR(30)
            AS
            BEGIN
                SET NOCOUNT ON;
            DELETE from [dbo].[bruker]
                WHERE Epost = @Epost;
            END
            GO
        /* Create Procedure [PROCEDURERemoveObjekt] */
            CREATE PROCEDURE [dbo].[PROCEDURERemoveObjekt]
                @idObjekt int
            AS
            BEGIN
                SET NOCOUNT ON;
            DELETE from [dbo].[Objekt]
                WHERE idObjekt = @idObjekt;
            END
            GO
        /* Create Procedure [PROCEDUREUpdateBruker_Verifisert] */
            CREATE PROCEDURE [dbo].[PROCEDUREUpdateBruker_Verifisert]
                @Epost VARCHAR(30),
                @Verifisert BIT
            AS
            BEGIN
                SET NOCOUNT ON;
            UPDATE [dbo].[bruker]
                SET Verifisert = @Verifisert
                WHERE Epost = @Epost;
            END
			GO
        /* Create Procedure [PROCEDUREUpgradeBruker_Sikkerhetsklarering] */
            CREATE PROCEDURE [dbo].[PROCEDUREUpgradeBruker_Sikkerhetsklarering]
                @Epost VARCHAR(30),
                @Sikkerhetsklarering INT
            AS
            BEGIN
                SET NOCOUNT ON;
            UPDATE [dbo].[bruker]
                set Sikkerhetsklarering = @Sikkerhetsklarering
                WHERE Epost = @Epost;                
            END
            GO
        /* Create Procedure [PROCEDUREinsertIntoTag_Objekt] */
            CREATE PROCEDURE [dbo].[PROCEDUREinsertIntoTag_Objekt]
                @IdObjekt int,
                @Tag varchar(30)
            AS
            BEGIN
                SET NOCOUNT ON;
            INSERT INTO [dbo].[Tag_Objekt]
                ([IdObjekt], [Tag])
            VALUES
                (@IdObjekt, @Tag)
            END
            GO
        /* Create Procedure [PROCEDUREinsertIntoTag_område] */
            CREATE PROCEDURE [dbo].[PROCEDUREinsertIntoTag_område]
                @IdOmråde int,
                @Tag varchar(30)
            AS
            BEGIN
                SET NOCOUNT ON;
            INSERT INTO [dbo].[Tag_område]
                ([IdOmråde], [Tag])
            VALUES
                (@IdOmråde, @Tag)
            END
            GO
        /* Create Procedure [PROCEDUREinsertIntoMåling] */
            CREATE PROCEDURE [dbo].[PROCEDUREinsertIntoMåling]
                @Navn_på_sensor VARCHAR(30),
                @Verdi FLOAT,
                @IdObjekt INTEGER,
                @Enhet VARCHAR(4)
            AS
            BEGIN
                SET NOCOUNT ON;
            INSERT INTO [dbo].[Måling]
                ([Navn_på_sensor], [Verdi], [Måling_id], [Dato], [IdObjekt], [Enhet])
            VALUES
                (@Navn_på_sensor, @Verdi, NEXT VALUE FOR dbo.SEQUENCEMålingMåling_id, DBO.FUNCdReturnDate(getdate()), @IdObjekt, @Enhet)
            END
            GO
        /* Create Procedure [PROCEDUREListAllBrukerFromDb] */
            CREATE PROCEDURE [dbo].[PROCEDUREListAllBrukerFromDb]
            AS
            BEGIN
                SET NOCOUNT ON;
            SELECT * FROM [dbo].[Bruker];
            END
            GO
        /* Create Procedure [PROCEDUREListAllKategorier_BildeFromDb] */
            CREATE PROCEDURE [dbo].[PROCEDUREListAllKategorier_BildeFromDb]
            AS
            BEGIN
                SET NOCOUNT ON;
            SELECT * FROM [dbo].[Kategorier_Bilde];
            END
            GO
        /* Create Procedure [PROCEDUREListAllMålingFromDb] */
            CREATE PROCEDURE [dbo].[PROCEDUREListAllMålingFromDb]
            AS
            BEGIN
                SET NOCOUNT ON;
            SELECT * FROM [dbo].[Måling];
            END        
            GO
        /* Create Procedure [PROCEDUREListAllOmrådeFromDb] */
            CREATE PROCEDURE [dbo].[PROCEDUREListAllOmrådeFromDb]
            AS
            BEGIN
                SET NOCOUNT ON;
            SELECT * FROM [dbo].[Område];
            END        
            GO
        /* Create Procedure [PROCEDUREListAllTag_OmrådeFromDb] */
            CREATE PROCEDURE [dbo].[PROCEDUREListAllTag_OmrådeFromDb]
            AS
            BEGIN
                SET NOCOUNT ON;
            SELECT * FROM [dbo].[Tag_område];
            END        
            GO
        /* Create Procedure [PROCEDUREListAllTag_ObjektFromDb] */
            CREATE PROCEDURE [dbo].[PROCEDUREListAllTag_ObjektFromDb]
            AS
            BEGIN
                SET NOCOUNT ON;
            SELECT * FROM [dbo].[Tag_Objekt];
            END        
            GO
        /* Create Procedure [PROCEDUREListAllPunkter_områdeFromDb] */
            CREATE PROCEDURE [dbo].[PROCEDUREListAllPunkter_områdeFromDb]
            AS
            BEGIN
                SET NOCOUNT ON;
            SELECT * FROM [dbo].[Punkter_område];
            END        
            GO
        /* Create Procedure [PROCEDUREListAllObjektFromDb] */
            /* Midlertidig erstattet med direkte spørring pga feil. */
            CREATE PROCEDURE [dbo].[PROCEDUREListAllObjektFromDb]
            @BrukersSikkerhetsklarering INTEGER
            AS
            BEGIN
                SET NOCOUNT ON;
            SELECT * FROM [dbo].[Objekt]
            WHERE Sikkerhetsklarering <= @BrukersSikkerhetsklarering;
            END
            GO
        /* Create Procedure [PROCEDURELoggFeil] */
            CREATE PROCEDURE [dbo].[PROCEDURELoggFeil]
			@Klasse VARCHAR(40),
                @Metode VARCHAR(40),
                @Feilmelding varchar(400)
            AS
            BEGIN
                SET NOCOUNT ON;
            INSERT INTO [dbo].[log_feil]
                ([Dato],[Klasse], [Metode], [Feilmelding])
            VALUES
                (DBO.FUNCdReturnDate(getdate()),@Klasse, @Metode, @Feilmelding)
            END
			GO
GO

/* INSERT */
    /* Insert into Bruker */
        INSERT INTO [dbo].[Bruker]
            ([Fornavn], [Etternavn], [Telefonnummer], [Epost], [Sikkerhetsklarering], [Passord],[tallkode],[Godkjent], [Verifisert])
        VALUES
            ('Ola', 'Nordmann', 99999999,'ola.nordman@stud.hvl.no', 1,'PassOla', 0, 1, 1),
            ('Kari', 'Nordmann',88888888, 'kari.nordman@stud.hvl.no', 2,'PassKari', 0, 1, 1),
            ('Erlend', 'Nordmann', 12345678,'erlend.nordman@stud.hvl.no', 3,'PassErlend', 0, 1, 1),
            ('Gjest', 'E. Bruker', 55585800,'gjest@stud.hvl.no', 3,'PassGjest', 0, 1, 1)
        GO
    /* Insert into Kategorier_Bilde */
        INSERT INTO [dbo].[Kategorier_Bilde]
            ([Kategorinavn], [Bilde])
        VALUES
            ('Termometer', NULL),
            ('Voltmeter', NULL)
        GO
    /* Insert into Objekt */
	    INSERT INTO [dbo].[Objekt]
            ([IdObjekt], [Navn], [Kategori], [Dato_opprettet], [Opprettet_av_bruker], [Sikkerhetsklarering ], [Kommentar],[lat],[Lang])
        VALUES
            (DEFAULT ,'12346','Termometer', DBO.FUNCdReturnDate(getdate()), 'Erlend Nordmann', 1, 'Romtemperatur for E117',60.36877532297345,5.350022493079979),
            (DEFAULT ,'12345','Voltmeter', DBO.FUNCdReturnDate(getdate()), 'Erlend Nordmann', 2, 'Sjekker at motoren har spenning over seg',60.36900255379234, 5.351733756019814)
        GO
    /* Insert into Tag_Objekt */
        INSERT INTO [dbo].[Tag_Objekt]
            ([IdObjekt], [Tag])
        VALUES
            (0,'1 Etasje'),
            (0,'Oppussing'),
            (0,'Simulert måling'),
            (1,'Gruppe B'),
            (1,'1 Etasje'),
            (1,'Simulert måling')
        GO
    /* Insert into Område */
        INSERT INTO [dbo].[Område]
            ([IdOmråde], [Navn], [Dato_opprettet], [Opprettet_av_bruker], [Kommentar], [Sikkerhetsklarering],[Farge])
        VALUES
            (DEFAULT, 'Opppusing', DBO.FUNCdReturnDate(getdate()), 'Kari Nordmann', 'Oppusing til 20.05.2023', 1,'Oransje'),
            (DEFAULT, 'Stengt', DBO.FUNCdReturnDate(getdate()), 'Kari Nordmann', 'Område stengt på grunn av lekkasje', 1,'Rødt')
        GO
    /* Insert into Punkter_område (for område) */
        INSERT INTO [dbo].[Punkter_område]
            ([IdOmråde], [Rekkefølge_punkter], [Lat], [Lang])
        VALUES
            (0, 0, 60.369222039111804, 5.35062411738252),
            (0, 1, 60.36951865650683, 5.350538881094243),
            (0, 2, 60.36955180888565, 5.351102144949048),
            (0, 3, 60.36926072984792, 5.351185293422851),
            (1, 0, 60.36915303815761, 5.349736592299403),
            (1, 1, 60.369173933669686, 5.350013298919372),
            (1, 2, 60.36907063874357, 5.350050777914007),
            (1, 3, 60.369052108703116, 5.349767691890698)
        GO
    /* Insert into Tag_område (for område) */
        INSERT INTO [dbo].[Tag_område]
            ([IdOmråde], [Tag])
        VALUES
            (0,'Oppussing'),
            (0,'3 Etasje'),
            (1,'Gruppe A'),
            (1,'1 Etasje')
        GO
    /* Insert into Måling */
        INSERT INTO [dbo].[Måling]
            ([Navn_på_sensor], [Verdi], [IdObjekt], [Måling_id], [Dato], [Enhet])
        VALUES
            (NULL, 23, 0, NEXT VALUE FOR dbo.SEQUENCEMålingMåling_id, DBO.FUNCdReturnDate(getdate()), 'C'),
            (NULL, 25, 1, NEXT VALUE FOR dbo.SEQUENCEMålingMåling_id, DBO.FUNCdReturnDate(getdate()), 'V')
        GO
/* The End */